# -*- coding: latin-1 -*-
#########################################################
#Author: Jean-Baptiste Fasquel, ISTIA, Angers University, France
#Copyright (C) 2014 Jean-Baptiste Fasquel
#########################################################

import cv2
import numpy as np
import helper

# -*- coding: latin-1 -*-
#########################################################
#Author: Jean-Baptiste Fasquel, ISTIA, Angers University, France
#Copyright (C) 2014 Jean-Baptiste Fasquel
#########################################################

import cv2
import numpy as np
import helper

##################################
#REFERENCE IMAGE
image_ref = cv2.imread('reference_image_logo.png')
mask=cv2.imread('reference_image_logo_mask.png',0) #0: pour un channel
detector = cv2.xfeatures2d.SURF_create()
keypoints_ref, descriptors_ref = detector.detectAndCompute(image_ref,mask)


image_display=np.zeros((image_ref.shape[0],2*image_ref.shape[1]))
##################################
#NEW IMAGES (NEW POSES)
cap = cv2.VideoCapture(0)
while(cap.isOpened()): #e.g. cam unplugged
    ret, image = cap.read()
    if ret==True:
        #DETECTOR
        keypoints, descriptors = detector.detectAndCompute(image,None)
        #MATCHING WITH REFERENCE IMAGE
        bf = cv2.BFMatcher(cv2.NORM_L2, crossCheck=True)
        matches = bf.match(descriptors_ref,descriptors)
        matches = sorted(matches, key = lambda x:x.distance)
        image_display=cv2.drawMatches(image_ref, keypoints_ref,image, keypoints, matches[:20],image_display)
        cv2.imshow('frame',image_display)
        if cv2.waitKey(1) & 0xFF == ord('q'):
            break
    else:
        break

# Release everything if job is finished
cap.release()
# out.release()
cv2.destroyAllWindows()